//
//  PrizeDetailInfoViewController.m
//  Open
//
//  Created by 雷俊博 on 2019/9/5.
//  Copyright © 2019 黄江涛 . All rights reserved.
//

#import "PrizeDetailInfoViewController.h"
#import "PrizeDetailCardView.h"
#import "PrizeDetailProcessView.h"
#import "SNXUXIANView.h"
#import "CTPrizeDetailProcessTableViewCell.h"

#import "UIColor+Hex.h"
#import "UIButton+ImageTitleSpacing.h"
#import "NSString+AttributedString.h"
#import "Constants.h"

#import "CTAPIBaseManager.h"

#import <Masonry.h>
#import <SVProgressHUD.h>
#import <UIImageView+WebCache.h>

@interface PrizeDetailInfoViewController ()<UITableViewDelegate,UITableViewDataSource>

@property (nonatomic, strong)UIScrollView *scrollView;

@property (nonatomic, strong)UIView *backView;

@property (nonatomic, strong)PrizeDetailCardView *cardView;

@property (nonatomic, strong)PrizeDetailProcessView *processView;

@property (nonatomic, strong)UIImageView * img_connect;
@property (nonatomic, strong)UIImageView * img_connect2;

@property (nonatomic, strong)UILabel *lb_number;

@property (nonatomic, strong)UILabel *lb_moneyNumber;
@property (nonatomic, strong)UILabel *lb_moneyUnit;


@property (nonatomic, strong)UILabel *lb_type;

@property (nonatomic, strong)UILabel *lb_date;

@property (nonatomic, strong)UIButton *btn_getCoins;

@property (nonatomic, strong)SNXUXIANView *lineView;

@property (nonatomic, strong)UILabel *lb_stateTitle;

@property (nonatomic, strong)UILabel *lb_state;

@property (nonatomic, strong)UIButton *btn_bindWx;

@property (nonatomic, strong)UIImageView *img_wxIcon;

@property (nonatomic, strong)UILabel *lb_prizeNameTitle;

@property (nonatomic, strong)UILabel *lb_prizeName;

@property (nonatomic, strong)UITableView *tableView;

@end

@implementation PrizeDetailInfoViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    
    self.view.backgroundColor = [UIColor colorWithHex:0xf8502c];
    
    [self.view addSubview:self.scrollView];
    
    if (self.type == CTListPrizeTypeCoins200 || self.type == CTListPrizeTypeCoins388 || self.type == CTListPrizeTypeCoins588) {
         self.lb_number.text = [self.contentDic[@"giftName"] stringByReplacingOccurrencesOfString:@"金币" withString:@""];
        self.lb_state.text = self.contentDic[@"lotterStatus"];
        self.lb_prizeName.text = self.contentDic[@"giftName"];
        NSString * state = self.contentDic[@"lotterStatus"];
        if ([state isEqualToString:@"未领取"]) {
            NSDate *startDate = [self getDateWithDateStr:self.contentDic[@"createTime"]];
            NSDate *endDate = [self getDateAfter30DaysWithCurrentDate:startDate];
           self.lb_date.text = [NSString stringWithFormat:@"有效期：%@-%@",[self getCustomDateStrWithDate:startDate],[self getCustomDateStrWithDate:endDate]];
            
            [self.btn_getCoins setTitle:@"立即领取" forState:UIControlStateNormal];
            [_btn_getCoins setTitleColor:[UIColor colorWithHex:0xfd592f] forState:UIControlStateNormal];
            
            _btn_getCoins.layer.cornerRadius = 20 * WIDTHRADIU;
            _btn_getCoins.layer.borderColor = [UIColor colorWithHex:0xfd592f].CGColor;
            _btn_getCoins.layer.borderWidth = 1.0;
            
            
        }else if ([state isEqualToString:@"已领取"]){
            NSDate *startDate = [self getDateWithDateStr:self.contentDic[@"createTime"]];
            NSDate *endDate = [self getDateAfter30DaysWithCurrentDate:startDate];
            self.lb_date.text = [NSString stringWithFormat:@"领取时间：%@",[self getCustomDateStrWithDate:startDate]];
            [self.btn_getCoins setTitle:@"已领取" forState:UIControlStateNormal];
            [_btn_getCoins setTitleColor:[UIColor colorWithHex:0xb3b3b3] forState:UIControlStateNormal];
            _btn_getCoins.layer.cornerRadius = 20 * WIDTHRADIU;
            _btn_getCoins.layer.borderColor = [UIColor colorWithHex:0xb3b3b3].CGColor;
            _btn_getCoins.layer.borderWidth = 1.0;
            _btn_getCoins.userInteractionEnabled = NO;
        }else if ([state isEqualToString:@"已过期"]){
            NSDate *startDate = [self getDateWithDateStr:self.contentDic[@"createTime"]];
            NSDate *endDate = [self getDateAfter30DaysWithCurrentDate:startDate];
            self.lb_date.text = [NSString stringWithFormat:@"有效期：%@-%@",[self getCustomDateStrWithDate:startDate],[self getCustomDateStrWithDate:endDate]];
            [self.btn_getCoins setTitle:@"已过期" forState:UIControlStateNormal];
            [_btn_getCoins setTitleColor:[UIColor colorWithHex:0xb3b3b3] forState:UIControlStateNormal];
            _btn_getCoins.layer.cornerRadius = 20 * WIDTHRADIU;
            _btn_getCoins.layer.borderColor = [UIColor colorWithHex:0xb3b3b3].CGColor;
            _btn_getCoins.layer.borderWidth = 1.0;
            _btn_getCoins .userInteractionEnabled = NO;
        }
    }else if (self.type == CTListPrizeTypePackage2 || self.type == CTListPrizeTypePackage3 || self.type == CTListPrizeTypePackage10){
         self.lb_moneyNumber.text = [self.contentDic[@"giftName"] stringByReplacingOccurrencesOfString:@"元红包" withString:@""];
        self.lb_type.text = @"金币抽奖红包";
        self.lb_stateTitle.text = @"收款微信号";
        
        
        
        
        
        self.lb_prizeNameTitle.text = @"提现金额";
        self.lb_prizeName.text = [self.contentDic[@"giftName"] stringByReplacingOccurrencesOfString:@"话费" withString:@""];
        NSString * state = self.contentDic[@"lotterStatus"];
        
        if ([state isEqualToString:@"未领取"]) {
            NSDate *startDate = [self getDateWithDateStr:self.contentDic[@"createTime"]];
            NSDate *endDate = [self getDateAfter30DaysWithCurrentDate:startDate];
            self.lb_date.text = [NSString stringWithFormat:@"有效期：%@-%@",[self getCustomDateStrWithDate:startDate],[self getCustomDateStrWithDate:endDate]];
            
            [self.btn_getCoins setTitle:@"微信提现" forState:UIControlStateNormal];
            [_btn_getCoins setTitleColor:[UIColor colorWithHex:0xfd592f] forState:UIControlStateNormal];
            
            _btn_getCoins.layer.cornerRadius = 20 * WIDTHRADIU;
            _btn_getCoins.layer.borderColor = [UIColor colorWithHex:0xfd592f].CGColor;
            _btn_getCoins.layer.borderWidth = 1.0;
            
        }else if ([state isEqualToString:@"发放中"]){
            NSDate *startDate = [self getDateWithDateStr:self.contentDic[@"createTime"]];
            NSDate *endDate = [self getDateAfter30DaysWithCurrentDate:startDate];
            self.lb_date.text = [NSString stringWithFormat:@"有效期：%@-%@",[self getCustomDateStrWithDate:startDate],[self getCustomDateStrWithDate:endDate]];
            
            [self.btn_getCoins setTitle:@"发放中..." forState:UIControlStateNormal];
            [_btn_getCoins setTitleColor:[UIColor colorWithHex:0xfd592f] forState:UIControlStateNormal];
            
            _btn_getCoins.layer.cornerRadius = 20 * WIDTHRADIU;
            _btn_getCoins.layer.borderColor = [UIColor colorWithHex:0xfd592f].CGColor;
            _btn_getCoins.layer.borderWidth = 1.0;
        }else if ([state isEqualToString:@"已领取"]){
            NSDate *startDate = [self getDateWithDateStr:self.contentDic[@"createTime"]];
            NSDate *endDate = [self getDateAfter30DaysWithCurrentDate:startDate];
            self.lb_date.text = [NSString stringWithFormat:@"领取时间：%@",[self getCustomDateStrWithDate:startDate]];
            [self.btn_getCoins setTitle:@"已领取" forState:UIControlStateNormal];
            [_btn_getCoins setTitleColor:[UIColor colorWithHex:0xb3b3b3] forState:UIControlStateNormal];
            _btn_getCoins.layer.cornerRadius = 20 * WIDTHRADIU;
            _btn_getCoins.layer.borderColor = [UIColor colorWithHex:0xb3b3b3].CGColor;
            _btn_getCoins.layer.borderWidth = 1.0;
            _btn_getCoins .userInteractionEnabled = NO;
        }else if ([state isEqualToString:@"已过期"]){
            NSDate *startDate = [self getDateWithDateStr:self.contentDic[@"createTime"]];
            NSDate *endDate = [self getDateAfter30DaysWithCurrentDate:startDate];
            self.lb_date.text = [NSString stringWithFormat:@"有效期：%@-%@",[self getCustomDateStrWithDate:startDate],[self getCustomDateStrWithDate:endDate]];
            [self.btn_getCoins setTitle:@"已过期" forState:UIControlStateNormal];
            [_btn_getCoins setTitleColor:[UIColor colorWithHex:0xb3b3b3] forState:UIControlStateNormal];
            _btn_getCoins.layer.cornerRadius = 20 * WIDTHRADIU;
            _btn_getCoins.layer.borderColor = [UIColor colorWithHex:0xb3b3b3].CGColor;
            _btn_getCoins.layer.borderWidth = 1.0;
            _btn_getCoins .userInteractionEnabled = NO;
            
        }else if ([state isEqualToString:@"领取失败"]){
            NSDate *startDate = [self getDateWithDateStr:self.contentDic[@"createTime"]];
            NSDate *endDate = [self getDateAfter30DaysWithCurrentDate:startDate];
            self.lb_date.text = [NSString stringWithFormat:@"有效期：%@-%@",[self getCustomDateStrWithDate:startDate],[self getCustomDateStrWithDate:endDate]];
            
            [self.btn_getCoins setTitle:@"重新领取" forState:UIControlStateNormal];
            [_btn_getCoins setTitleColor:[UIColor colorWithHex:0xfd592f] forState:UIControlStateNormal];
            
            _btn_getCoins.layer.cornerRadius = 20 * WIDTHRADIU;
            _btn_getCoins.layer.borderColor = [UIColor colorWithHex:0xfd592f].CGColor;
            _btn_getCoins.layer.borderWidth = 1.0;
        }
        
        
        [self requestBindAPI];
        
        
        
    }
    
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    
    [JANALYTICSService startLogPageView:@"奖品详情"];
    [MobClick beginLogPageView:@"奖品详情"];
    
}

- (void)viewWillDisappear:(BOOL)animated
{
    [super viewWillDisappear:animated];
    
    
    [JANALYTICSService stopLogPageView:@"奖品详情"];
    [MobClick endLogPageView:@"奖品详情"];
}

- (void)viewWillLayoutSubviews
{
    [super viewWillLayoutSubviews];
    
    
    
    
    if (self.type == CTListPrizeTypeCoins200 ||  self.type == CTListPrizeTypeCoins388 || self.type == CTListPrizeTypeCoins588 ) {
        [self.lb_number mas_makeConstraints:^(MASConstraintMaker *make) {
            make.centerX.equalTo(self.cardView);
            make.top.offset(35 * WIDTHRADIU);
            make.height.offset(55 * WIDTHRADIU);
        }];
        [self.lb_type mas_makeConstraints:^(MASConstraintMaker *make) {
            make.centerX.equalTo(self.cardView);
            make.top.equalTo(self.lb_number.mas_bottom).offset(14 * WIDTHRADIU);
            make.height.offset(14 * WIDTHRADIU);
        }];
    }else{
        
        [self.lb_moneyNumber mas_makeConstraints:^(MASConstraintMaker *make) {
            make.centerX.equalTo(self.cardView).offset(-15 * WIDTHRADIU);
            make.top.offset(35 * WIDTHRADIU);
            make.height.offset(55 * WIDTHRADIU);
        }];
        
        [self.lb_moneyUnit mas_makeConstraints:^(MASConstraintMaker *make) {
            make.bottom.equalTo(self.lb_moneyNumber);
            make.left.equalTo(self.lb_moneyNumber.mas_right).offset(5 * WIDTHRADIU);
            make.height.offset(15 * WIDTHRADIU);
        }];
        
        [self.lb_type mas_makeConstraints:^(MASConstraintMaker *make) {
            make.centerX.equalTo(self.cardView);
            make.top.equalTo(self.lb_moneyNumber.mas_bottom).offset(14 * WIDTHRADIU);
            make.height.offset(14 * WIDTHRADIU);
        }];
        
        if (self.state == CTListPrizeStateUnGet ||  self.state == CTListPrizeStateInvalid || self.state == CTListPrizeTypeUnKnow) {
            
        }else{
            [self.img_connect mas_makeConstraints:^(MASConstraintMaker *make) {
                make.left.equalTo(self.cardView).offset(50 * WIDTHRADIU);
                make.top.equalTo(self.cardView.mas_bottom).offset(-14 * WIDTHRADIU);
                make.width.offset(10 * WIDTHRADIU);
                make.height.offset(43 * WIDTHRADIU);
            }];
            
            [self.img_connect2 mas_makeConstraints:^(MASConstraintMaker *make) {
                make.right.equalTo(self.cardView).offset(-50 * WIDTHRADIU);
                make.top.equalTo(self.cardView.mas_bottom).offset(-14 * WIDTHRADIU);
                make.width.offset(10 * WIDTHRADIU);
                make.height.offset(43 * WIDTHRADIU);
            }];
        }
        
       
    }
    
    
   
    
    [self.lb_date mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(self.cardView);
        make.top.equalTo(self.lb_type.mas_bottom).offset(6 * WIDTHRADIU);
        make.height.offset(14 * WIDTHRADIU);
    }];
    
    [self.btn_getCoins mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.lb_date.mas_bottom).offset(20 * WIDTHRADIU);
        make.left.offset(30 * WIDTHRADIU);
        make.right.offset(-30 * WIDTHRADIU);
        make.height.offset(40 * WIDTHRADIU);
    }];
    
    [self.lineView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.btn_getCoins.mas_bottom).offset(21 * WIDTHRADIU);
        make.left.offset(8 * WIDTHRADIU);
        make.right.offset(- 8 * WIDTHRADIU);
        make.height.offset(0.5);
    }];
    
    [self.lb_stateTitle mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.lineView.mas_bottom).offset(15 * WIDTHRADIU);
        make.left.offset(14 * WIDTHRADIU);
        make.height.offset(14 * WIDTHRADIU);
    }];
    
    if (self.type == CTListPrizeTypeCoins200 || self.type == CTListPrizeTypeCoins388 || self.type == CTListPrizeTypeCoins588) {
        [self.lb_state mas_makeConstraints:^(MASConstraintMaker *make) {
            make.centerY.equalTo(self.lb_stateTitle);
            make.right.offset(-27 * WIDTHRADIU);
            make.height.offset(14 * WIDTHRADIU);
        }];
    }else {
        [self.btn_bindWx mas_makeConstraints:^(MASConstraintMaker *make) {
            make.centerY.equalTo(self.lb_stateTitle);
            make.right.offset(-27 * WIDTHRADIU);
            make.height.offset(14 * WIDTHRADIU);
        }];
        
        [self.img_wxIcon mas_makeConstraints:^(MASConstraintMaker *make) {
            make.centerY.equalTo(self.btn_bindWx);
            make.right.equalTo(self.btn_bindWx.mas_left).offset(-3);
            make.width.height.offset(20 * WIDTHRADIU);
        }];
    }
    
   
    
    [self.lb_prizeNameTitle mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.lb_stateTitle.mas_bottom).offset(15 * WIDTHRADIU);
        make.left.equalTo(self.lb_stateTitle);
        make.height.offset(14 * WIDTHRADIU);
    }];
    
    [self.lb_prizeName mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.lb_prizeNameTitle);
         make.right.offset(-27 * WIDTHRADIU);
        make.height.offset(14 * WIDTHRADIU);
    }];
    
    
    
   
    
   
   
    
}


#pragma mark - UITableViewDataSource
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section;
{
    return 3;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *stringIdentifier = @"cell";
    
    CTPrizeDetailProcessTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:stringIdentifier];
    
    cell.currented = YES;
    if (indexPath.row == 0) {
        cell.hasUpLine = NO;
        cell.hasDownLine = YES;
        
    }else if (indexPath.row == 1){
        cell.hasUpLine = YES;
        cell.hasDownLine = YES;
    }else if (indexPath.row == 2){
        cell.hasUpLine = YES;
        cell.hasDownLine = NO;
    }
    
    [cell reloadUIWithData:self.contentDic state:self.state Index:indexPath.row];
    return cell;
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
    return 54 * WIDTHRADIU;
}

#pragma mark - 字符串转日期后30天后的日期
- (NSDate *)getDateWithDateStr:(NSString *)str
{
    NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
    [dateFormatter setDateFormat:@"yyyy/MM/dd"];
    NSDate *date = [dateFormatter dateFromString:str];
    
    return date;
}

- (NSDate *)getDate2WithDateStr:(NSString *)str
{
    NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
    [dateFormatter setDateFormat:@"yyyy-MM-dd HH:mm:ss"];
    NSDate *date = [dateFormatter dateFromString:str];
    
    return date;
}

- (NSDate *)getDateAfter30DaysWithCurrentDate:(NSDate *)date
{
    NSDate *newDate = [date dateByAddingTimeInterval:30 * 60 * 60  * 24];
    return newDate;
}

- (NSString *)getCustomDateStrWithDate:(NSDate *)date
{
    // 获取代表公历的NSCalendar对象
    NSCalendar *gregorian = [[NSCalendar alloc]
                             initWithCalendarIdentifier:NSCalendarIdentifierGregorian];
    // 定义一个时间字段的旗标，指定将会获取指定年、月、日、时、分、秒的信息
    unsigned unitFlags = NSCalendarUnitYear |
    NSCalendarUnitMonth |  NSCalendarUnitDay |
    NSCalendarUnitHour |  NSCalendarUnitMinute |
    NSCalendarUnitSecond | NSCalendarUnitWeekday;
    // 获取不同时间字段的信息
    NSDateComponents* comp = [gregorian components: unitFlags
                                          fromDate:date];
    // 获取各时间字段的数值
    NSLog(@"现在是%ld年" , comp.year);
    NSLog(@"现在是%ld月 " , comp.month);
    NSLog(@"现在是%ld日" , comp.day);
    NSLog(@"现在是%ld时" , comp.hour);
    NSLog(@"现在是%ld分" , comp.minute);
    NSLog(@"现在是%ld秒" , comp.second);
    NSLog(@"现在是星期%ld" , comp.weekday);
    
    return [NSString stringWithFormat:@"%ld.%ld.%ld",(long)comp.year,comp.month,comp.day];
    
}

- (NSString *)getCustom2DateStrWithDate:(NSDate *)date
{
    // 获取代表公历的NSCalendar对象
    NSCalendar *gregorian = [[NSCalendar alloc]
                             initWithCalendarIdentifier:NSCalendarIdentifierGregorian];
    // 定义一个时间字段的旗标，指定将会获取指定年、月、日、时、分、秒的信息
    unsigned unitFlags = NSCalendarUnitYear |
    NSCalendarUnitMonth |  NSCalendarUnitDay |
    NSCalendarUnitHour |  NSCalendarUnitMinute |
    NSCalendarUnitSecond | NSCalendarUnitWeekday;
    // 获取不同时间字段的信息
    NSDateComponents* comp = [gregorian components: unitFlags
                                          fromDate:date];
    // 获取各时间字段的数值
    NSLog(@"现在是%ld年" , comp.year);
    NSLog(@"现在是%ld月 " , comp.month);
    NSLog(@"现在是%ld日" , comp.day);
    NSLog(@"现在是%ld时" , comp.hour);
    NSLog(@"现在是%ld分" , comp.minute);
    NSLog(@"现在是%ld秒" , comp.second);
    NSLog(@"现在是星期%ld" , comp.weekday);
    
    return [NSString stringWithFormat:@"%ld.%ld.%ld   %ld:%ld",(long)comp.year,comp.month,comp.day,comp.hour,comp.minute];
    
}

#pragma mark - event response
- (void)btnClick:(UIButton *)sender
{
    
    
    if (self.type == CTListPrizeTypePackage2 ||self.type == CTListPrizeTypePackage3 || self.type == CTListPrizeTypePackage10) {
        
        if (![[UIApplication sharedApplication] canOpenURL:[NSURL URLWithString:@"wechat://"]] ) {
            [SVProgressHUD showErrorWithStatus:@"您未安装微信\n只支持微信提现哟!"];
            
            return;
        }
        
        if ([sender.titleLabel.text isEqualToString:@"绑定微信提现"]) {
            [self getUserInfoForPlatform:UMSocialPlatformType_WechatSession];
        }else if ([sender.titleLabel.text isEqualToString:@"微信提现"]){
            
            
           
           
            
            
            [self withdrawCash];
            sender.userInteractionEnabled = NO;
        }else if ([sender.titleLabel.text isEqualToString:@"重新领取"]){
            [self withdrawCash];
            sender.userInteractionEnabled = NO;
        }
       
    }else if (self.type == CTListPrizeTypeCoins200 || self.type == CTListPrizeTypeCoins388 || self.type == CTListPrizeTypeCoins588){
        if ([sender.titleLabel.text isEqualToString:@"立即领取"]) {
            [self requestGetCoins];
        }
    }
    
    
}

- (void)bindWXClick:(UIButton *)sender
{
    if ([sender.titleLabel.text isEqualToString:@"未绑定"]) {
        
        
        if (![[UIApplication sharedApplication] canOpenURL:[NSURL URLWithString:@"wechat://"]] ) {
            [SVProgressHUD showErrorWithStatus:@"您未安装微信\n只支持微信提现哟!"];
            
            return;
        }
        
        [self getUserInfoForPlatform:UMSocialPlatformType_WechatSession];
        
        sender.userInteractionEnabled = NO;
    }
}


#pragma mark - api 调用
- (void)requestBindAPI
{
    
    WeakSelf
    NSString *url = [NSString stringWithFormat:@"%@scorepay/validateBind",CoinsBaseUrl];
    
    NSDictionary *dic = @{
                          @"userid":[NSNumber numberWithInteger:[getPeopleID PeopleID]],
                          @"telephone": [EnercryTool encryptUseDES:[getPeopleID PeopleIphoneNmber] key:DESKEY],
                          @"requestTimeStamp":[NSNumber numberWithInteger:[self getNowTimeTimestamp3]],
                          @"fromModel":@"2",
                          @"accounttype":[NSNumber numberWithInt:1],
                          };
    
    
    NSArray *result = [dic.allKeys sortedArrayUsingComparator:^NSComparisonResult(id  _Nonnull obj1, id  _Nonnull obj2) {
        
        NSLog(@"%@~%@",obj1,obj2); //3~4 2~1 3~1 3~2
        
        return [obj1 compare:obj2]; //升序
        
    }];
    NSString *sign = nil;
    for (int i = 0; i < result.count; i++) {
        NSString *key = result[i];
        if (i==0) {
            sign = [NSString stringWithFormat:@"%@=%@",key,dic[key]];
        }else{
            
            sign = [NSString stringWithFormat:@"%@&%@=%@",sign,key,dic[key]];
        }
    }
    
    sign = [NSString stringWithFormat:@"%@&weface9578",sign];
    
    NSMutableDictionary *params = [[NSMutableDictionary alloc]initWithDictionary:dic];
    
    NSString *signString = [[MyMD5 md5:sign] lowercaseString];
    [params setObject:signString forKey:@"sign"];
    
    [CTAPIBaseManager POST:url params:params completionHandler:^(id  _Nonnull responseObject, NSError * _Nonnull error) {
        
        self.btn_bindWx.userInteractionEnabled = NO;
        
        if (error) {
            [SVProgressHUD showInfoWithStatus:@"无网络"];
            return ;
        }
        
        if (responseObject) {
            NSNumber *code = responseObject[@"code"];
            NSString *des = responseObject[@"des"];
            if ([code isKindOfClass:[NSNumber class]]) {
                if (code.integerValue == 0) {
                    if (weakSelf.state == CTListPrizeStateUnGet) {
                        [weakSelf.btn_getCoins setTitle:@"微信提现" forState:UIControlStateNormal];
                    }
                    
                    NSString *screenName = [NSString blankString:responseObject[@"result"][@"screenName"]] ? @"" : responseObject[@"result"][@"screenName"];
                    NSString *iconUrl = [NSString blankString:responseObject[@"result"][@"iconUrl"]] ? @"" : responseObject[@"result"][@"iconUrl"];
                    
                    [weakSelf.btn_bindWx setTitle:screenName forState:UIControlStateNormal];
                    [weakSelf.btn_bindWx  layoutButtonWithEdgeInsetsStyle:GLButtonEdgeInsetsStyleRight imageTitleSpace:3];
                    
                    [weakSelf.img_wxIcon sd_setImageWithURL:[NSURL URLWithString:iconUrl] placeholderImage:[UIImage imageNamed:@"my_information_headportrait_default"]];
                    
                    self.btn_bindWx.userInteractionEnabled = NO;
                    
                    
                }else if (code.integerValue == 1018){
                    if (weakSelf.state == CTListPrizeStateUnGet) {
                        [weakSelf.btn_getCoins setTitle:@"绑定微信提现" forState:UIControlStateNormal];
                    }
                    
                }else{
                    [SVProgressHUD showInfoWithStatus:des];
                }
            }else{
                [SVProgressHUD showInfoWithStatus:@"服务器错误"];
            }
        }
    }];
}


- (void)bindWxApiWithParams:(NSDictionary *)dic
{
    NSString *url = [NSString stringWithFormat:@"%@scorepay/accountBind",CoinsBaseUrl];
    
    
    
    NSDictionary *dic2 = @{
                          @"userid":[NSNumber numberWithInteger:[getPeopleID PeopleID]],
                          @"telephone": [EnercryTool encryptUseDES:[getPeopleID PeopleIphoneNmber] key:DESKEY],
                          @"accounttype":[NSNumber numberWithInt:1],
                          @"requestTimeStamp":[NSNumber numberWithInteger:[self getNowTimeTimestamp3]],
                          @"fromModel":@"2",
                          @"accounttype":[NSNumber numberWithInt:1],
                          };
    
    NSMutableDictionary *dic3 = [[NSMutableDictionary alloc]initWithDictionary:dic];
    
    [dic3 addEntriesFromDictionary:dic2];
    
    
    NSArray *result = [dic3.allKeys sortedArrayUsingComparator:^NSComparisonResult(id  _Nonnull obj1, id  _Nonnull obj2) {
        
        NSLog(@"%@~%@",obj1,obj2); //3~4 2~1 3~1 3~2
        
        return [obj1 compare:obj2]; //升序
        
    }];
    NSString *sign = nil;
    for (int i = 0; i < result.count; i++) {
        NSString *key = result[i];
        if (i==0) {
            sign = [NSString stringWithFormat:@"%@=%@",key,dic3[key]];
        }else{
            
            sign = [NSString stringWithFormat:@"%@&%@=%@",sign,key,dic3[key]];
        }
    }
    
    sign = [NSString stringWithFormat:@"%@&weface9578",sign];
    
    NSMutableDictionary *params = [[NSMutableDictionary alloc]initWithDictionary:dic3];
    
    NSString *signString = [[MyMD5 md5:sign] lowercaseString];
    [params setObject:signString forKey:@"sign"];
    
    NSString *username = dic3[@"screenname"];
    [params setObject:[username stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLPathAllowedCharacterSet]] forKey:@"screenname"];
    
    WeakSelf
    [CTAPIBaseManager POST:url params:params completionHandler:^(id  _Nonnull responseObject, NSError * _Nonnull error) {
        
        if (error) {
            [SVProgressHUD showInfoWithStatus:@"无网络"];
            return ;
        }
        
        if (responseObject) {
            NSNumber *code = responseObject[@"code"];
            NSString *des = responseObject[@"des"];
            if ([code isKindOfClass:[NSNumber class]]) {
                if (code.integerValue == 0) {
                    
                    weakSelf.clickBlock(YES);
                    
                    [weakSelf.btn_getCoins setTitle:@"微信提现" forState:UIControlStateNormal];
                    
                    NSString *screenName = username ? username : @"";
                    NSString *iconUrl = dic[@"iconurl"];
                    
                    [weakSelf.btn_bindWx setTitle:screenName forState:UIControlStateNormal];
                    [weakSelf.btn_bindWx  layoutButtonWithEdgeInsetsStyle:GLButtonEdgeInsetsStyleRight imageTitleSpace:3];
                    
                    [weakSelf.img_wxIcon sd_setImageWithURL:[NSURL URLWithString:iconUrl] placeholderImage:[UIImage imageNamed:@"my_information_headportrait_default"]];
                    
                }else if (code.integerValue == 1018){
                    [weakSelf.btn_getCoins setTitle:@"绑定微信提现" forState:UIControlStateNormal];
                }else{
                    [SVProgressHUD showInfoWithStatus:des];
                }
            }else{
                [SVProgressHUD showInfoWithStatus:@"服务器错误"];
            }
        }
    }];
}

#pragma mark - 绑定微信
- (void)getUserInfoForPlatform:(UMSocialPlatformType)platformType
{WeakSelf
    [[UMSocialManager defaultManager] getUserInfoWithPlatform:platformType currentViewController:self completion:^(id result, NSError *error) {
        NSLog(@">>>>>wx>>result:%@, error:%@",result,error);
        
        if (error) {
            [SVProgressHUD showErrorWithStatus:@"微信授权失败!"];
            return;
        }
        
        UMSocialUserInfoResponse *resp = result;
        if(resp.uid ){
            if (!resp.name) {
                resp.name =@"";
            }
            if (!resp.iconurl) {
                resp.iconurl=@"";
            }
            
           
        }
        // 第三方登录数据(为空表示平台未提供)
        // 授权数据
        NSLog(@" uid: %@", resp.uid);//uuid
        NSLog(@" openid: %@", resp.openid);
        NSLog(@" accessToken: %@", resp.accessToken);
        NSLog(@" refreshToken: %@", resp.refreshToken);
        NSLog(@" expiration: %@", resp.expiration);
        
        // 用户数据
        NSLog(@" name: %@", resp.name);
        NSLog(@" iconurl: %@", resp.iconurl);
        NSLog(@" gender: %@", resp.gender);
        
        // 第三方平台SDK原始数据
        NSLog(@" originalResponse: %@", resp.originalResponse);
        
        NSDictionary *dic = @{
                              @"iconurl":resp.iconurl ? resp.iconurl :@"",
                              @"openid":resp.openid ? resp.openid : @"",
                              @"uid":resp.uid ? resp.uid : @"",
                              @"token":resp.accessToken ? resp.accessToken : @"",
                              @"screenname":resp.name ? resp.name : @"",
                              };
        [weakSelf bindWxApiWithParams:dic];
    }];
}

- (void)withdrawCash
{
    
    

    
    [SVProgressHUD shows];
    
    WeakSelf
    NSString *url = [NSString stringWithFormat:@"%@scorepay/cashMoney",CoinsBaseUrl];
    
    NSDictionary *dic = @{
                          @"recordId":self.contentDic[@"recordId"],
                          @"userorderno":self.contentDic[@"userorderno"] ? self.contentDic[@"userorderno"] : @"",
                          @"giftId":self.contentDic[@"giftId"],
                          @"userid":[NSNumber numberWithInteger:[getPeopleID PeopleID]],
                          @"telephone": [EnercryTool encryptUseDES:[getPeopleID PeopleIphoneNmber] key:DESKEY],
                          @"requestTimeStamp":[NSNumber numberWithInteger:[self getNowTimeTimestamp3]],
                          @"paystyle":[NSNumber numberWithInt:1],
                          };
    
    
    NSArray *result = [dic.allKeys sortedArrayUsingComparator:^NSComparisonResult(id  _Nonnull obj1, id  _Nonnull obj2) {
        
        NSLog(@"%@~%@",obj1,obj2); //3~4 2~1 3~1 3~2
        
        return [obj1 compare:obj2]; //升序
        
    }];
    NSString *sign = nil;
    for (int i = 0; i < result.count; i++) {
        NSString *key = result[i];
        if (i==0) {
            sign = [NSString stringWithFormat:@"%@=%@",key,dic[key]];
        }else{
            
            sign = [NSString stringWithFormat:@"%@&%@=%@",sign,key,dic[key]];
        }
    }
    
    sign = [NSString stringWithFormat:@"%@&kw#8ra",sign];
    
    NSMutableDictionary *params = [[NSMutableDictionary alloc]initWithDictionary:dic];
    
    NSString *signString = [[MyMD5 md5:sign] lowercaseString];
    [params setObject:signString forKey:@"sign"];
    
    [CTAPIBaseManager POST:url params:params completionHandler:^(id  _Nonnull responseObject, NSError * _Nonnull error) {
        
        weakSelf.btn_getCoins.userInteractionEnabled = YES;
        
        [SVProgressHUD doneShow];
        [SVProgressHUD dismiss];
        
        if (error) {
            [SVProgressHUD showInfoWithStatus:@"无网络"];
            return ;
        }
        
        if (responseObject) {
            NSNumber *code = responseObject[@"code"];
            NSString *des = responseObject[@"des"];
            if ([code isKindOfClass:[NSNumber class]]) {
                if (code.integerValue == 0) {
                    
                    weakSelf.clickBlock(YES);
                    [weakSelf.btn_getCoins setTitle:@"已领取" forState:UIControlStateNormal];
                    [weakSelf.btn_getCoins setTitleColor:[UIColor colorWithHex:0xb3b3b3] forState:UIControlStateNormal];
                    weakSelf.btn_getCoins.layer.cornerRadius = 20 * WIDTHRADIU;
                    weakSelf.btn_getCoins.layer.borderColor = [UIColor colorWithHex:0xb3b3b3].CGColor;
                    weakSelf.btn_getCoins.layer.borderWidth = 1.0;
                    weakSelf.btn_getCoins .userInteractionEnabled = NO;
                    
                    NSString *payTime = responseObject[@"result"][@"payTime"];
                    weakSelf.lb_date.text = [NSString stringWithFormat:@"领取时间：%@",[weakSelf getCustom2DateStrWithDate:[weakSelf getDate2WithDateStr:payTime]]];
                    
                    
                    NSMutableDictionary *dic = [weakSelf.contentDic mutableCopy];
                    
                    [dic setObject:[weakSelf getCustomDateStrWithDate:[weakSelf getDate2WithDateStr:payTime]] forKey:@"payTime"];
                    
                    [dic setObject:[weakSelf getCustomDateStrWithDate:[NSDate date]] forKey:@"orderRequestTime"];
                    
                    self.contentDic = dic;
                    
                    if (weakSelf.state == CTListPrizeStateUnGet) {
                       
                        
                        weakSelf.state = CTListPrizeStateReceived;
                        
                        [weakSelf withDrawrefreshUI];
                    }else if (weakSelf.state == CTListPrizeStateFailure){
                        weakSelf.state = CTListPrizeStateReceived;
                        
                        [weakSelf.tableView reloadData];
                    }
                    
                  
                    
                   
                }else if (code.integerValue == 1017){
                    [SVProgressHUD showInfoWithStatus:@"提现失败"];
                }else if (code.integerValue == 1018){
                    [SVProgressHUD showInfoWithStatus:@"账户未授权"];
                }else if (code.integerValue == 1023){
                    [SVProgressHUD showInfoWithStatus:@"账户异常"];
                }else if (code.integerValue == 1024){
                    [SVProgressHUD showInfoWithStatus:@"账户异常"];
                }else{
                    [SVProgressHUD showInfoWithStatus:@"    请确定微信账号           \n  是否已实名   "];
                    if (self.state == CTListPrizeStateUnGet) {
                        
                          weakSelf.clickBlock(YES);
                          [weakSelf.btn_getCoins setTitle:@"重新领取" forState:UIControlStateNormal];
                        
                        weakSelf.state = CTListPrizeStateFailure;
                        [weakSelf withDrawrefreshUI];
                    }
                    
                }
            } else{
                [SVProgressHUD showInfoWithStatus:@"无网络"];
            }
        }
        
    }];
}


//领取金币
- (void)requestGetCoins
{
    
    [SVProgressHUD shows];
    
    WeakSelf
    NSString *url = [NSString stringWithFormat:@"%@score/excharge",CoinsBaseUrl];
    
    NSDictionary *dic = @{
                          @"telphone": [EnercryTool encryptUseDES:[getPeopleID PeopleIphoneNmber] key:DESKEY],
                          @"sysorderNo":self.contentDic[@"recordId"] ? [NSString stringWithFormat:@"%@",self.contentDic[@"recordId"]] : @"",
                          @"userId":[NSString stringWithFormat:@"%ld",[getPeopleID PeopleID]],
                          @"requestTimeStamp":[NSNumber numberWithInteger:[self getNowTimeTimestamp3]]
                          };
    
    
    NSArray *result = [dic.allKeys sortedArrayUsingComparator:^NSComparisonResult(id  _Nonnull obj1, id  _Nonnull obj2) {
        
        NSLog(@"%@~%@",obj1,obj2); //3~4 2~1 3~1 3~2
        
        return [obj1 compare:obj2]; //升序
        
    }];
    NSString *sign = nil;
    for (int i = 0; i < result.count; i++) {
        NSString *key = result[i];
        if (i==0) {
            sign = [NSString stringWithFormat:@"%@=%@",key,dic[key]];
        }else{
            
            sign = [NSString stringWithFormat:@"%@&%@=%@",sign,key,dic[key]];
        }
    }
    
    sign = [NSString stringWithFormat:@"%@&kk#d12",sign];
    
    NSMutableDictionary *params = [[NSMutableDictionary alloc]initWithDictionary:dic];
    
     NSString *signString = [[MyMD5 md5:sign] lowercaseString];
    [params setObject:signString forKey:@"sign"];
    
    [CTAPIBaseManager POST:url params:params completionHandler:^(id  _Nonnull responseObject, NSError * _Nonnull error) {
        
        [SVProgressHUD doneShow];
        [SVProgressHUD dismiss];
        
        if (error) {
            [SVProgressHUD showInfoWithStatus:@"无网络"];
            return ;
        }
        
        if (responseObject) {
            NSNumber *code = responseObject[@"code"];
            NSString *des = responseObject[@"des"];
            if ([code isKindOfClass:[NSNumber class]]) {
                if (code.integerValue == 0) {
                    
                    weakSelf.clickBlock(YES);
                    [weakSelf.btn_getCoins setTitle:@"已领取" forState:UIControlStateNormal];
                    [weakSelf.btn_getCoins setTitleColor:[UIColor colorWithHex:0xb3b3b3] forState:UIControlStateNormal];
                    weakSelf.btn_getCoins.layer.cornerRadius = 20 * WIDTHRADIU;
                    weakSelf.btn_getCoins.layer.borderColor = [UIColor colorWithHex:0xb3b3b3].CGColor;
                    weakSelf.btn_getCoins.layer.borderWidth = 1.0;
                    weakSelf.btn_getCoins .userInteractionEnabled = NO;
                    weakSelf.lb_state.text = @"已领取";
                }else{
                    [SVProgressHUD showInfoWithStatus:des];
                }
            } else{
                [SVProgressHUD showInfoWithStatus:@"服务器错误"];
            }
        }
        
    }];
}

//点击提现后,重新刷新UI
- (void)withDrawrefreshUI
{
    [self.backView addSubview:self.processView];
    [self.backView  addSubview:self.img_connect];
    [self.backView  addSubview:self.img_connect2];
    
    [self.img_connect mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.cardView).offset(50 * WIDTHRADIU);
        make.top.equalTo(self.cardView.mas_bottom).offset(-14 * WIDTHRADIU);
        make.width.offset(10 * WIDTHRADIU);
        make.height.offset(43 * WIDTHRADIU);
    }];
    
    [self.img_connect2 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(self.cardView).offset(-50 * WIDTHRADIU);
        make.top.equalTo(self.cardView.mas_bottom).offset(-14 * WIDTHRADIU);
        make.width.offset(10 * WIDTHRADIU);
        make.height.offset(43 * WIDTHRADIU);
    }];
}

#pragma mark - 获取当前时间戳

-(NSInteger )getNowTimeTimestamp3{
    
    NSDateFormatter *formatter = [[NSDateFormatter alloc] init] ;
    
    [formatter setDateStyle:NSDateFormatterMediumStyle];
    
    [formatter setTimeStyle:NSDateFormatterShortStyle];
    
    [formatter setDateFormat:@"YYYY-MM-dd HH:mm:ss SSS"]; // ----------设置你想要的格式,hh与HH的区别:分别表示12小时制,24小时制
    
    //设置时区,这个对于时间的处理有时很重要
    
    NSTimeZone* timeZone = [NSTimeZone timeZoneWithName:@"Asia/Beijing"];
    
    [formatter setTimeZone:timeZone];
    
    NSDate *datenow = [NSDate date];//现在时间,你可以输出来看下是什么格式
    
    NSInteger timeSp = [datenow timeIntervalSince1970]*1000;
    
    return timeSp;
}


#pragma mark - getters and setters
- (UIScrollView *)scrollView
{
    
    if (!_scrollView) {
        _scrollView = [[UIScrollView alloc]initWithFrame:CGRectMake(0, 0, ScreenWidth, ScreenHeight - cl_kNavigationBarHeight)];
        _scrollView.backgroundColor = [UIColor clearColor];
        _scrollView.contentSize = CGSizeMake(ScreenWidth, ScreenHeight);
        
        
        _scrollView.showsHorizontalScrollIndicator = NO;
        _scrollView.showsVerticalScrollIndicator = NO;
        
        [_scrollView addSubview:self.backView];
    }
    return _scrollView;
    
}

- (UIView *)backView
{
    if (!_backView) {
        _backView = [[UIView alloc]initWithFrame:CGRectMake(0, 0, ScreenWidth, ScreenHeight * 1)];
        _backView.backgroundColor = [UIColor clearColor];
        [_backView addSubview:self.cardView];
        
        if (self.type == CTListPrizeTypeCoins200 ||  self.type == CTListPrizeTypeCoins388 || self.type == CTListPrizeTypeCoins588) {
           
        }else{
            if (self.state == CTListPrizeStateUnGet || self.state == CTListPrizeStateInvalid || self.state == CTListPrizeTypeUnKnow) {
                
            }else{
                [_backView addSubview:self.processView];
                [_backView addSubview:self.img_connect];
                [_backView addSubview:self.img_connect2];
            }
            
        }
      
    }
    return _backView;
}

- (PrizeDetailCardView *)cardView
{
    if (!_cardView) {
        _cardView = [[PrizeDetailCardView alloc]initWithFrame:CGRectMake(10 * WIDTHRADIU, 10 * WIDTHRADIU , ScreenWidth - 20 * WIDTHRADIU, 304 * WIDTHRADIU)];
        _cardView.backgroundColor = [UIColor whiteColor];
        
        if (self.type == CTListPrizeTypeCoins200 || self.type == CTListPrizeTypeCoins388 || self.type == CTListPrizeTypeCoins588) {
            [_cardView addSubview:self.lb_number];
        }else{
            [_cardView addSubview:self.lb_moneyNumber];
            [_cardView addSubview:self.lb_moneyUnit];
            
        }
        
        [_cardView addSubview:self.lb_type];
        [_cardView addSubview:self.lb_date];
        [_cardView addSubview:self.btn_getCoins];
        [_cardView addSubview:self.lineView];
        [_cardView addSubview:self.lb_stateTitle];
        
        if ( self.type == CTListPrizeTypeCoins200 || self.type == CTListPrizeTypeCoins388 || self.type == CTListPrizeTypeCoins588) {
            [_cardView addSubview:self.lb_state];
        }else{
            [_cardView addSubview:self.btn_bindWx];
            [_cardView addSubview:self.img_wxIcon];
        }
        
        [_cardView addSubview:self.lb_prizeNameTitle];
        [_cardView addSubview:self.lb_prizeName];
    }
    return _cardView;
}

- (PrizeDetailProcessView *)processView
{
    if (!_processView) {
        _processView = [[PrizeDetailProcessView alloc]initWithFrame:CGRectMake(10 * WIDTHRADIU, 329 * WIDTHRADIU,  ScreenWidth - 20 * WIDTHRADIU, 210 * WIDTHRADIU)];
        _processView.backgroundColor = [UIColor whiteColor];
        
        [_processView addSubview:self.tableView];
    }
    return _processView;
}

- (UIImageView *)img_connect
{
    if (!_img_connect) {
        _img_connect = [[UIImageView alloc]init];
        _img_connect.image = [UIImage imageNamed:@"关联"];
    }
    return _img_connect;
}

- (UIImageView *)img_connect2
{
    if (!_img_connect2) {
        _img_connect2 = [[UIImageView alloc]init];
        _img_connect2.image = [UIImage imageNamed:@"关联"];
    }
    return _img_connect2;
}

- (UILabel *)lb_number
{
    if (!_lb_number) {
        _lb_number = [[UILabel alloc]init];
        _lb_number.textColor = [UIColor colorWithHex:0xfe5733];
        _lb_number.textAlignment = NSTextAlignmentCenter;
        _lb_number.font = [UIFont systemFontOfSize:70 * WIDTHRADIU];
        _lb_number.text = @"10";
        
    }
    return _lb_number;
}

- (UILabel *)lb_moneyNumber
{
    if (!_lb_moneyNumber) {
        _lb_moneyNumber = [[UILabel alloc]init];
        _lb_moneyNumber.textColor = [UIColor colorWithHex:0xfe5733];
        _lb_moneyNumber.textAlignment = NSTextAlignmentCenter;
        _lb_moneyNumber.font = [UIFont systemFontOfSize:70 * WIDTHRADIU];
        _lb_moneyNumber.text = @"10";
        
    }
    return _lb_moneyNumber;
}

- (UILabel *)lb_moneyUnit
{
    if (!_lb_moneyUnit) {
        _lb_moneyUnit = [[UILabel alloc]init];
        _lb_moneyUnit.textColor = [UIColor colorWithHex:0xfe5733];
        _lb_moneyUnit.textAlignment = NSTextAlignmentCenter;
        _lb_moneyUnit.font = [UIFont systemFontOfSize:15 * WIDTHRADIU];
        _lb_moneyUnit.text = @"元";
        
    }
    return _lb_moneyUnit;
}




//- (UILabel *)lb_unit
//{
//    if (!_lb_unit) {
//        _lb_unit = [[UILabel alloc]init];
//        _lb_unit.textColor = [UIColor whiteColor];
//        _lb_unit.textAlignment = NSTextAlignmentCenter;
//        _lb_unit.font = [UIFont systemFontOfSize:13 * WIDTHRADIU];
//        _lb_unit.text = @"元";
//    }
//    return _lb_unit;
//}

- (UILabel *)lb_type
{
    if (!_lb_type) {
        _lb_type = [[UILabel alloc]init];
        _lb_type.textAlignment = NSTextAlignmentCenter;
        _lb_type.textColor = [UIColor colorWithHex:0x808080];
        _lb_type.font = [UIFont systemFontOfSize:14 * WIDTHRADIU];
        _lb_type.text = @"金币奖励";
    }
    return _lb_type;
}

- (UILabel *)lb_date
{
    if (!_lb_date) {
        _lb_date = [[UILabel alloc]init];
        _lb_date.text = @"有效期：2019.09.02-2019.10.02";
        _lb_date.textColor = [UIColor colorWithHex:0x808080];
        _lb_date.font = [UIFont systemFontOfSize:14 * WIDTHRADIU];
    }
    return _lb_date;
}

- (UIButton *)btn_getCoins
{
    if (!_btn_getCoins) {
        _btn_getCoins = [UIButton buttonWithType:UIButtonTypeCustom];
        _btn_getCoins.titleLabel.font = [UIFont systemFontOfSize:15 * WIDTHRADIU];
        _btn_getCoins.backgroundColor = [UIColor clearColor];
        
        [_btn_getCoins addTarget:self action:@selector(btnClick:) forControlEvents:UIControlEventTouchUpInside];
        
    }
    return _btn_getCoins;
}

- (SNXUXIANView *)lineView
{
    if (!_lineView) {
        _lineView = [[SNXUXIANView alloc]init];
    }
    return _lineView;
}

- (UILabel *)lb_stateTitle
{
    if (!_lb_stateTitle) {
        _lb_stateTitle = [[UILabel alloc]init];
        _lb_stateTitle.text = @"领取状态";
        _lb_stateTitle.textColor = [UIColor colorWithHex:0x808080];
        _lb_stateTitle.font = [UIFont systemFontOfSize:14 * WIDTHRADIU];
    }
    return _lb_stateTitle;
}

- (UILabel *)lb_state
{
    if (!_lb_state) {
        _lb_state = [[UILabel alloc]init];
        _lb_state.text = @"实时到账";
        _lb_state.textColor = [UIColor colorWithHex:0x808080];
        _lb_state.font = [UIFont systemFontOfSize:14 * WIDTHRADIU];
    }
    return _lb_state;
}

- (UIButton *)btn_bindWx
{
    if (!_btn_bindWx) {
        _btn_bindWx = [UIButton buttonWithType:UIButtonTypeCustom];
        [_btn_bindWx setTitleColor:[UIColor colorWithHex:0x808080] forState:UIControlStateNormal];
        _btn_bindWx.titleLabel.font = [UIFont systemFontOfSize:14 * WIDTHRADIU];
        [_btn_bindWx setImage:[UIImage imageNamed:@"my_arrow_normal"] forState:UIControlStateNormal];
        [_btn_bindWx setTitle:@"未绑定" forState:UIControlStateNormal];
        [_btn_bindWx layoutButtonWithEdgeInsetsStyle:GLButtonEdgeInsetsStyleRight imageTitleSpace:0];
        
        [_btn_bindWx addTarget:self action:@selector(bindWXClick:) forControlEvents:UIControlEventTouchUpInside];
        
    }
    return _btn_bindWx;
}

- (UIImageView *)img_wxIcon
{
    if (!_img_wxIcon) {
        _img_wxIcon = [[UIImageView alloc]init];
        _img_wxIcon.layer.cornerRadius = 10 * WIDTHRADIU;
        _img_wxIcon.layer.masksToBounds = YES;
    }
    return _img_wxIcon;
}


- (UILabel *)lb_prizeNameTitle
{
    if (!_lb_prizeNameTitle) {
        _lb_prizeNameTitle = [[UILabel alloc]init];
        _lb_prizeNameTitle.text = @"奖品名称";
        _lb_prizeNameTitle.textColor = [UIColor colorWithHex:0x808080];
        _lb_prizeNameTitle.font = [UIFont systemFontOfSize:14 * WIDTHRADIU];
    }
    return _lb_prizeNameTitle;
}

- (UILabel *)lb_prizeName
{
    if (!_lb_prizeName) {
        _lb_prizeName = [[UILabel alloc]init];
        _lb_prizeName.text = @"200金币";
        _lb_prizeName.textColor = [UIColor colorWithHex:0x808080];
        _lb_prizeName.font = [UIFont systemFontOfSize:14 * WIDTHRADIU];
    }
    return _lb_prizeName;
}


- (UITableView *)tableView
{
    if (!_tableView ) {
        _tableView = [[UITableView alloc]initWithFrame:CGRectMake(10 * WIDTHRADIU, 30 * WIDTHRADIU, ScreenWidth - 40 * WIDTHRADIU, 160 * WIDTHRADIU) style:UITableViewStylePlain];
        _tableView.showsHorizontalScrollIndicator = YES;
        _tableView.showsVerticalScrollIndicator = NO;
        _tableView.separatorStyle = UITableViewCellSeparatorStyleNone;
        _tableView.backgroundColor = [UIColor clearColor];
        _tableView.delegate = self;
        _tableView.dataSource = self;
        _tableView.scrollEnabled = NO;
        [_tableView registerClass:[CTPrizeDetailProcessTableViewCell class] forCellReuseIdentifier:@"cell"];
        _tableView.tableFooterView = [UIView new];
        
        
    }
    return _tableView;
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
